﻿using System;
using System.Drawing;
using System.Reflection;
using System.Windows.Forms;
using Greatis.PrintSuite.Providers;

namespace WindowsFormsApplication1
{
  public partial class MainForm : Form
  {
    private Random r = new Random();

    public MainForm()
    {
      InitializeComponent();
      Font = SystemFonts.MessageBoxFont;
    }

    private void linkLabel_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
    {
      System.Diagnostics.Process.Start((sender as LinkLabel).Text);
    }

    private void MainForm_Load(object sender, System.EventArgs e)
    {
      printPreviewControl.AutoZoom = true;
    }

    private void gridProvider_MeasureColumn(object sender, MeasureColumnEventArgs e)
    {
      e.Width = 100 + e.Column * 10;
      e.Unit = GraphicsUnit.Display;
      e.HasMoreColumns = e.Column < 9;
    }

    private void gridProvider_MeasureRow(object sender, MeasureRowEventArgs e)
    {
      e.Height = 50 + e.Row * 10;
      e.Unit = GraphicsUnit.Display;
    }

    private void gridProvider_CellSpan(object sender, CellSpanEventArgs e)
    {
      if (e.Column == 3 && e.Row == 7)
      {
        e.RowSpan = 3;
        e.ColumnSpan = 4;
      }
      if (e.Column == 2 && e.Row == 3)
      {
        e.ColumnSpan = 7;
        e.RowSpan = 2;
      }
    }

    private void gridProvider_CellFill(object sender, PrintCellEventArgs e)
    {
      Brush b;
      if (e.SpanRowPortion != -1)
        b = new SolidBrush(Color.FromArgb(255, 128, 0));
      else
      {
        int c = 56 + r.Next(200);
        b = new SolidBrush(Color.FromArgb(c, c, c));
      }
      e.Graphics.FillRectangle(b, e.CellBounds);
    }

    private void gridProvider_PrintCellContent(object sender, PrintCellEventArgs e)
    {
      string s;
      if (e.SpanRowPortion != -1)
        s = string.Format("{0}.{1}/{2}.{3}", e.Column, e.Row, e.SpanColumnPortion, e.SpanRowPortion);
      else
        s = string.Format("{0}.{1}", e.Column, e.Row);
      using (Brush b = new SolidBrush(gridProvider.DefaultLayout.ForeColor))
        e.Graphics.DrawString(s, gridProvider.DefaultLayout.Font, b, e.CellPaddingBounds.Left, e.CellPaddingBounds.Top);
      e.HasMoreRows = e.Row < 11;
    }

    private void tabControl_Selected(object sender, TabControlEventArgs e)
    {
      if (e.TabPage == tabPagePrint) printPreviewControl.InvalidatePreview();
    }
  }
}
