﻿using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;
using Greatis.PrintSuite.Providers;

namespace WindowsFormsApplication1
{
  public partial class MainForm : Form
  {
    private Random r = new Random();

    public MainForm()
    {
      InitializeComponent();
      Font = SystemFonts.MessageBoxFont;
    }

    private void linkLabel_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
    {
      System.Diagnostics.Process.Start((sender as LinkLabel).Text);
    }

    private void MainForm_Load(object sender, System.EventArgs e)
    {
      printPreviewControl.AutoZoom = true;
    }

    private string GetName(int i)
    {
      switch (i)
      {
        case 1: return "Ann";
        case 2: return "Mary";
        case 3: return "John";
        case 4: return "Benjamin Sherman Klinger III";
        default: return "";
      }
    }

    private void textGridProvider_CellText(object sender, Greatis.PrintSuite.Providers.CellTextEventArgs e)
    {
      if (e.Row == 0) e.Text = GetName(e.Column);
      else
        if (e.Column == 0) e.Text = GetName(e.Row);
        else
          e.Text = string.Format("{0}:{1}", r.Next(0, 9), r.Next(0, 9));
      e.HasMoreRows = e.Row < 4;
    }

    private void textGridProvider_MeasureColumn(object sender, MeasureColumnEventArgs e)
    {
      e.Width = e.ContentBounds.Width / 5;
      e.HasMoreColumns = e.Column < 4;
    }

    private void textGridProvider_PrintCellContent(object sender, PrintCellEventArgs e)
    {
      if (e.Column == e.Row)
      {
        // fill in the cell
        using (Brush b = new HatchBrush(HatchStyle.BackwardDiagonal, Color.Black, Color.White))
          e.Graphics.FillRectangle(b, e.CellBounds);
        // we have to set HasMoreRows, because default value is false,
        // and each cell can stop printing if returns false
        e.HasMoreRows = e.Row < 4;
      }
      else textGridProvider.OnPrintCellContent(e);
    }

    private void tabControl_Selected(object sender, TabControlEventArgs e)
    {
      if (e.TabPage == tabPagePrint) printPreviewControl.InvalidatePreview();
    }

  }
}
