﻿using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;
using Greatis.PrintSuite;

namespace ContinuePrintExample
{
  public partial class MainForm : Form
  {
    public MainForm()
    {
      InitializeComponent();
      Font = SystemFonts.MessageBoxFont;
    }

    private void linkLabel_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
    {
      System.Diagnostics.Process.Start((sender as LinkLabel).Text);
    }

    private void contentProvider100_PrintContent(object sender, Greatis.PrintSuite.PrintContentEventArgs e)
    {
      if (e.ContentBounds.Height < 100)
      {
        e.ContinuePrint = Greatis.PrintSuite.ContinuePrint.NextPage;
        e.Skipped = true;
      }
      else
      {
        Rectangle r = new Rectangle(e.ContentBounds.Left, e.ContentBounds.Top, e.ContentBounds.Width, 100);
        e.ContentBounds = new Rectangle(r.Left, r.Top + r.Height, r.Width, e.ContentBounds.Height - r.Height);
        r.Inflate(0, -10);
        using (GraphicsPath p = Service.CreateRoundRectPath(r, 40)) e.Graphics.FillPath(Brushes.Yellow, p);
        StringFormat sf = new StringFormat();
        sf.Alignment = StringAlignment.Center;
        sf.LineAlignment = StringAlignment.Center;
        using (Font f = new Font("Trebuchet MS", 24))
          e.Graphics.DrawString("100." + e.ProviderContent.ToString(), f, Brushes.Black, r, sf);
				if (e.ProviderContent > 8) e.ContinuePrint = Greatis.PrintSuite.ContinuePrint.Finish;
        else
					if (e.ContentBounds.Height >= 100) e.ContinuePrint = Greatis.PrintSuite.ContinuePrint.ThisPage;
					else e.ContinuePrint = Greatis.PrintSuite.ContinuePrint.NextPage;
      }
    }

    private void contentProvider200_PrintContent(object sender, PrintContentEventArgs e)
    {
      if (e.ContentBounds.Height < 200)
      {
				e.ContinuePrint = Greatis.PrintSuite.ContinuePrint.NextPage;
        e.Skipped = true;
      }
      else
      {
        Rectangle r = new Rectangle(e.ContentBounds.Left, e.ContentBounds.Top, e.ContentBounds.Width, 200);
        e.ContentBounds = new Rectangle(r.Left, r.Top + r.Height, r.Width, e.ContentBounds.Height - r.Height);
        r.Inflate(0, -10);
        using (GraphicsPath p = Service.CreateRoundRectPath(r, 40)) e.Graphics.FillPath(Brushes.LightGreen, p);
        StringFormat sf = new StringFormat();
        sf.Alignment = StringAlignment.Center;
        sf.LineAlignment = StringAlignment.Center;
        using (Font f = new Font("Trebuchet MS", 48))
          e.Graphics.DrawString("200." + e.ProviderContent.ToString(), f, Brushes.Black, r, sf);
				if (e.ProviderContent > 8) e.ContinuePrint = Greatis.PrintSuite.ContinuePrint.Finish;
        else
					if (e.ContentBounds.Height >= 200) e.ContinuePrint = Greatis.PrintSuite.ContinuePrint.ThisPage;
					else e.ContinuePrint = Greatis.PrintSuite.ContinuePrint.NextPage;
      }
    }

    private void contentProvider300_PrintContent(object sender, PrintContentEventArgs e)
    {
      if (e.ContentBounds.Height < 300)
      {
				e.ContinuePrint = Greatis.PrintSuite.ContinuePrint.NextPage;
        e.Skipped = true;
      }
      else
      {
        Rectangle r = new Rectangle(e.ContentBounds.Left, e.ContentBounds.Top, e.ContentBounds.Width, 300);
        e.ContentBounds = new Rectangle(r.Left, r.Top + r.Height, r.Width, e.ContentBounds.Height - r.Height);
        r.Inflate(0, -10);
        using (GraphicsPath p = Service.CreateRoundRectPath(r, 40)) e.Graphics.FillPath(Brushes.LightBlue, p);
        StringFormat sf = new StringFormat();
        sf.Alignment = StringAlignment.Center;
        sf.LineAlignment = StringAlignment.Center;
        using (Font f = new Font("Trebuchet MS", 72))
          e.Graphics.DrawString("300." + e.ProviderContent.ToString(), f, Brushes.Black, r, sf);
				if (e.ProviderContent > 8) e.ContinuePrint = Greatis.PrintSuite.ContinuePrint.Finish;
        else
					if (e.ContentBounds.Height >= 300) e.ContinuePrint = Greatis.PrintSuite.ContinuePrint.ThisPage;
					else e.ContinuePrint = Greatis.PrintSuite.ContinuePrint.NextPage;
      }
    }

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			printPreviewControl.AutoZoom = true;
		}

  }
}
