﻿using System.Drawing;
using System.Windows.Forms;
using Greatis.PrintSuite;

namespace WindowsFormsApplication1
{
  public partial class MainForm : Form
  {
    public MainForm()
    {
      InitializeComponent();
      Font = SystemFonts.MessageBoxFont;
    }

    private void linkLabel_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
    {
      System.Diagnostics.Process.Start((sender as LinkLabel).Text);
    }

    private void MainForm_Load(object sender, System.EventArgs e)
    {
      printPreviewControl.AutoZoom = true;
      printPreviewControl.Columns = 2;
    }

    private void contentProvider1_PrintContent(object sender, PrintContentEventArgs e)
    {
      Point[] trigon = 
      {
        new Point(e.ContentBounds.Right, e.ContentBounds.Top),
        new Point(e.ContentBounds.Right, e.ContentBounds.Bottom),
        new Point(e.ContentBounds.Left, (e.ContentBounds.Top + e.ContentBounds.Bottom) / 2)
      };
      e.Graphics.FillPolygon(Brushes.Orange, trigon);
      StringFormat sf = new StringFormat();
      sf.Alignment = StringAlignment.Far;
      sf.LineAlignment = StringAlignment.Center;
      using (Font f = new Font("Trebuchet MS", 100))
        e.Graphics.DrawString(
          string.Format("{0}/{1}", e.DocumentPage, e.ProviderPage),
          f,
          Brushes.Black,
          new Point(
            3 * (e.ContentBounds.Left + e.ContentBounds.Right) / 4,
            (e.ContentBounds.Top + e.ContentBounds.Bottom) / 2),
          sf);
      if (e.DocumentPage < 5) e.ContinuePrint = ContinuePrint.NextPage;
    }

    private void contentProvider2_PrintContent(object sender, PrintContentEventArgs e)
    {
      Point[] trigon = 
      {
        new Point(e.ContentBounds.Left, e.ContentBounds.Top),
        new Point(e.ContentBounds.Left, e.ContentBounds.Bottom),
        new Point(e.ContentBounds.Right,(e.ContentBounds.Top + e.ContentBounds.Bottom) / 2)
      };
      e.Graphics.FillPolygon(Brushes.Orange, trigon);
      StringFormat sf = new StringFormat();
      sf.LineAlignment = StringAlignment.Center;
      using (Font f = new Font("Trebuchet MS", 100))
        e.Graphics.DrawString(
          string.Format("{0}/{1}", e.DocumentPage, e.ProviderPage),
          f,
          Brushes.Black,
          new Point(
            (e.ContentBounds.Left + e.ContentBounds.Right) / 4,
            (e.ContentBounds.Top + e.ContentBounds.Bottom) / 2),
          sf);
      if (e.DocumentPage < 5) e.ContinuePrint = ContinuePrint.NextPage;
    }
  }
}
