﻿using System.Drawing;
using System.Windows.Forms;
using Greatis.PrintSuite;

namespace WindowsFormsApplication1
{
  public partial class MainForm : Form
  {
    public MainForm()
    {
      InitializeComponent();
      Font = SystemFonts.MessageBoxFont;
    }

    private void linkLabel_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
    {
      System.Diagnostics.Process.Start((sender as LinkLabel).Text);
    }

    private void MainForm_Load(object sender, System.EventArgs e)
    {
      printPreviewControl.AutoZoom = true;
    }

    private void contentProvider_PrintContent(object sender, PrintContentEventArgs e)
    {
      // just 10 empty pages...
      if (e.ProviderPage < 9) e.ContinuePrint = ContinuePrint.NextPage;
      else e.ContinuePrint = ContinuePrint.Finish;
      // and just draw rectangle to see the content bounds, reduced by PageNumberProvider
      using (Pen p = new Pen(Color.Gray,10)) e.Graphics.DrawRectangle(p, e.ContentBounds);
    }

    private void tabControl_Selected(object sender, TabControlEventArgs e)
    {
      if (e.TabPage == tabPagePrint) printPreviewControl.InvalidatePreview();
    }
  }
}
