﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.Reflection;
using Greatis.PrintSuite;
using Greatis.PrintSuite.Providers;

namespace WindowsFormsApplication1
{
  public partial class MainForm : Form
  {
    public MainForm()
    {
      InitializeComponent();
      Font = SystemFonts.MessageBoxFont;
    }

    private void linkLabel_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
    {
      System.Diagnostics.Process.Start((sender as LinkLabel).Text);
    }

    private string AddAssembly(Type refType)
    {
      string text = string.Empty;
      Assembly asm = refType.Assembly;
      text += asm.GetName().Name + "\n\n";
      Type[] types = asm.GetTypes();
      foreach (Type t in types)
      {
        text += "  " + t.Name + '\n';
        MemberInfo[] members = t.GetProperties();
        foreach (MemberInfo m in members)
          if (m.DeclaringType == t) text += "    " + m.Name + '\n';
        members = t.GetEvents();
        foreach (MemberInfo m in members)
          if (m.DeclaringType == t) text += "    " + m.Name + '\n';
        members = t.GetMethods(BindingFlags.Public | BindingFlags.Static);
        foreach (MemberInfo m in members)
          if (m.DeclaringType == t) text += "    " + m.Name + '\n';
        members = t.GetMembers(BindingFlags.Public | BindingFlags.Static);
        foreach (MemberInfo m in members)
          if (m.DeclaringType == t && m.Name != "value__") text += "    " + m.Name + '\n';
        text += '\n';
      }
      return text + '\f'; // new page
    }

    private void MainForm_Load(object sender, System.EventArgs e)
    {
      printPreviewControl.AutoZoom = true;
      string text = AddAssembly(typeof(Service));
      text += AddAssembly(typeof(PrintProvider));
			text += AddAssembly(typeof(Greatis.PrintSuite.Providers.TextProvider));
      textProvider.Text = text;
    }
  }
}
